﻿Imports BinaryTree.Tree
Imports BinaryTree.Tree.TreeLocation

Public Class Form1

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim LTree As New Tree
        LTree.Value = "Ali"

        Dim RTree As New Tree
        RTree.Value = "Hany"

        Dim T As New Tree
        T.Value = "Sayd"
        T.Left = LTree
        T.Right = RTree

        MsgBox(T.Value)          ' Sayd
        MsgBox(T.Left.Value)   ' Ali
        MsgBox(T.Right.Value) ' Hany


        Dim T2 As New Tree
        T2.Value = " Sayd"
        T2.Add("Ali", Tree.TreeLocation.LeftTree)
        T2.Add("Hany", TreeLocation.RightTree)

        T2.Left.Add("Ahmad", LeftTree)
        T2.Left.Add("Sami", RightTree)
        T2.Right.Add("Ali", LeftTree)
        T2.Right.Add("Rami", RightTree)

        MsgBox(T2.Value)          ' Sayd 
        MsgBox(T2.Left.Value)   ' Ali
        MsgBox(T2.Right.Value) ' Hany

        Dim T3 As New Tree
        T3.Value = "Sayd"

        Dim LT As Tree = T3.Add("Ali", LeftTree)
        Dim RT As Tree = T3.Add("Hany", RightTree)

        LT.Add("Ahmad", LeftTree) : LT.Add("Sami", RightTree)
        RT.Add("Ali", LeftTree) : RT.Add("Rami", RightTree)

    End Sub

    Sub WriteTree(ByVal T As Tree)
        Static Level As Integer = 1
        TxtTest.AppendText(T.Value & vbCrLf)
        Level += 1
        If Level > 5 Then ' شرط التوقف
            Level -= 1 ' إنقاص المستوى قبل الرجوع إلى الأب
            Exit Sub
        End If

        WriteTree(T.Add(StrDup(3 * Level, " ") & _
                           "LTree Lvel " + Trim(Level), LeftTree))
        WriteTree(T.Add(StrDup(3 * Level, " ") & _
                           "RTree Lvel " + Trim(Level), RightTree))
        Level -= 1 ' إنقاص المستوى قبل الرجوع إلى الأب
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim T As New Tree
        T.Value = "Tree Root"
        WriteTree(T)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim A() As String = {"Ali", "Basem", "Kmal", "Nesma", "Hala", "Heba"}
        Dim T As Tree
        For I As Integer = 0 To UBound(A)
            AddToBST(T, A(I))
        Next
        A = GetSortedBSTArray(T)
        For I As Integer = 0 To UBound(A)
            MsgBox(A(I))
        Next
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click        
        TxtTest.Lines = Tree.SortTree(TxtTest.Lines)
    End Sub
End Class
