﻿Public Class Form1
    Sub WriteTree(ByVal T As Tree(Of String))
        Static Level As Integer = 1
        TxtTest.AppendText(T.Value & vbCrLf)
        Level += 1
        If Level > 5 Then
            Level -= 1
            Exit Sub
        End If

        WriteTree(T.AddNode(StrDup(3 * Level, " ") & "LTree Lvel " + Trim(Level)))
        WriteTree(T.AddNode(StrDup(3 * Level, " ") & "LTree Lvel " + Trim(Level)))
        Level -= 1 ' إنقاص المستوى قبل الرجوع إلى الأب
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim T As New Tree(Of String)
        T.Value = "Root"
        WriteTree(T)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim T As New Tree(Of String)
        T.Value = "Ahmad"
        T.AddNode("Ali").AddNode("Mohammed").AddNode("Hany")
        T.AddNode("Wael").AddNode("Ramy")
        T.AddNode("Said").AddNode("Magdi").AddNode("Zaid").AddNode("Mahmood")
        PrintTree(T)
    End Sub

    Sub PrintTree(ByVal T As Tree(Of String))
        Static Level As Integer = 1
        TxtTest.AppendText(StrDup(3 * Level, " ") & T.Value & vbCrLf)

        ' طباعة العناصر الفرعية للشجرة
        Level += 1
        If T.Nodes.MoveFirst Then
            Do
                PrintTree(T.Nodes.CurItem)
            Loop While T.Nodes.MoveNext
        End If

        Level -= 1 ' إنقاص المستوى قبل الرجوع إلى الأب
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        MsgBox(ParseTree(GetTokens(TxtTest.Text)))
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        MsgBox(FullParseTree(GetTokens(TxtTest.Text)))
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim Path As String = "C:\Windows\System32"
        Dim T As New Tree(Of String)
        T.AddNode(Path)
        DirTree(T, Path)
        PrintTree(T)
    End Sub
End Class
