﻿Public Class Form1

    Dim UnDo As New Stack(Of String)
    Dim DontChange As Boolean
    Dim SomeChanges As Boolean
    Private Sub TxtTest_TextChanged(ByVal sender As Object, ByVal e As EventArgs) Handles TxtTest.TextChanged
        If DontChange Then Exit Sub
        AdjustUnDo()
        Dim T As String = TxtTest.Text
        Dim LastChar As String
        If Len(T) > 0 Then
            LastChar = Mid(T, Len(T), 1)
        Else
            LastChar = ""
        End If
        Select Case LastChar
            Case " ", vbCr, vbLf, ".", ",", "?", "!", "(", ")"
                UnDo.Push(T)
                SomeChanges = False
            Case Else
                SomeChanges = True
        End Select

        ReDo.Clear()
        BtUnDo.Enabled = True
        BtReDo.Enabled = False
        
    End Sub

    Private Sub BtUnDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtUnDo.Click
        If SomeChanges Then
            UnDo.Push(TxtTest.Text)
            SomeChanges = False
        End If

        ReDo.Push(UnDo.Pop())
        BtReDo.Enabled = True

        DontChange = True
        If UnDo.IsEmpty Then
            BtUnDo.Enabled = False
            TxtTest.Text = ""
        Else
            TxtTest.Text = UnDo.Peek
        End If
        DontChange = False
    End Sub


    Dim ReDo As New Stack(Of String)
    Private Sub BtReDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtReDo.Click
        DontChange = True
        TxtTest.Text = ReDo.Pop()
        DontChange = False
        UnDo.Push(TxtTest.Text)
        BtUnDo.Enabled = True
        BtReDo.Enabled = Not ReDo.IsEmpty

    End Sub

    Sub AdjustUnDo()
        If ReDo.Count = 0 Then Exit Sub
        Dim TmpStack As New Stack(Of String)
        Dim ReDoPeek As String
        Dim UnDoPeek As String = UnDo.Peek
        Do
            ReDoPeek = ReDo.Pop()
            UnDo.Push(ReDoPeek)
            If ReDo.IsEmpty Then Exit Do
            TmpStack.Push(ReDoPeek)
        Loop
        Do Until TmpStack.IsEmpty
            UnDo.Push(TmpStack.Pop)
        Loop
        ReDo.Clear()
        UnDo.Push(UnDoPeek)
    End Sub


End Class
