﻿Public Class Form1
    
    Structure Student
        Dim ID As Integer
        <VBFixedString(20)> Dim Name As String
        Dim Grade As Integer
    End Structure

    Private Sub BtSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSave.Click
        If Not IsNumeric(TxtID.Text) Then
            Dim Msg As String = "رقم الطالب يجب أن يكون عددا صحيحا"
            MsgBox(Msg, MsgBoxStyle.Critical) : Exit Sub
        End If
        If Len(TxtName.Text) > 20 Then
            Dim Msg As String = "يجب ألا يزيد اسم الطالب عن 20 حرفا"
            MsgBox(Msg, MsgBoxStyle.Critical) : Exit Sub
        End If
        If Not IsNumeric(TxtGrade.Text) Then
            Dim Msg As String = "درجة الطالب يجب أن تكون عددا صحيحا"
            MsgBox(Msg, MsgBoxStyle.Critical) : Exit Sub
        End If
        Dim Std As Student
        Std.ID = TxtID.Text : Std.Name = TxtName.Text
        Std.Grade = TxtGrade.Text

        Dim No As Integer = FreeFile()
        Try
            FileOpen(No, "c:\Students.txt", OpenMode.Random, , , Len(Std))
            FilePut(No, Std, Std.ID)
            TxtID.Text = Std.ID + 1
            TxtName.Text = ""
            TxtGrade.Text = ""
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            FileClose(No)
        End Try

    End Sub

    Private Sub BtSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSearch.Click
        If IsNumeric(TxtSearch.Text) Then
            ShowStudent(TxtSearch.Text)
        Else
            MsgBox("أدخل عددا صحيحا ليتم البحث عن الطالب الذي يمثله", _
                             MsgBoxStyle.Critical)
        End If

    End Sub

    Sub ShowStudent(ByVal Id As Integer)
        Dim Std As Student, No As Integer = FreeFile()
        Try
            FileOpen(No, "c:\Students.txt", OpenMode.Random, , , Len(Std))
            Dim L As Integer = LOF(No) / Len(Std)
            If Id > L Then
                MsgBox("تم تسجيل بيانات " & CStr(L) & " من الطلاب فقط", MsgBoxStyle.Critical)
            Else : FileGet(No, Std, Id)
                TxtId.Text = Std.ID : TxtName.Text = Std.Name
                TxtGrade.Text = Std.Grade
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally : FileClose(No)
        End Try
    End Sub

End Class
