﻿Public Class XorEncoder
    Implements IEncoder

    Sub New()
        MyBase.New()
    End Sub

    Sub New(ByVal Key1 As Byte, ByVal Key2 As Byte)
        _Key1 = Key1
        _Key2 = Key2
    End Sub

    Public Property Key1 As Byte Implements IEncoder.Key1
    Public Property Key2 As Byte Implements IEncoder.Key2

    Public Function Endode(ByVal B As Byte) As Byte Implements IEncoder.Endode
        B = B Xor _Key1
        If _Key2 Mod 2 = 0 Then Return (B Xor _Key2)
        Return B Xor Not _Key2
    End Function

    Public Function Dedode(ByVal B As Byte) As Byte Implements IEncoder.Dedode
        If _Key2 Mod 2 = 0 Then
            B = B Xor _Key2
        Else
            B = B Xor Not _Key2
        End If
        Return B Xor _Key1
    End Function

End Class
