﻿Module Data

    Structure UserData
        Dim UserNo As Integer
        Dim UserID As Integer
    End Structure

    Structure UserData2
        <VBFixedString(10)> Dim UserName As String
        <VBFixedString(6)> Dim Password As String
    End Structure

    Function CheckUser(ByVal User As UserData) _
         As Boolean
        Dim Fs As New FileStream("C:\UsersData.txt")
        Const ChecKByte As Byte = 236
        ' التأكد أن رقم المستخدم ليس أكبر من عدد المستخدمين المحفوظين في الملف
        If Fs.ReadInteger < User.UserNo Then
            ' يجب التأكد من إغلاق الملف قبل مغادرة الدالة
            Fs.Close() : Return False
        End If
        ' التأكد أن طول السجل المحفوظ يساوي طول السجل المطلوب قراءته
        If Fs.ReadInteger <> Len(User) Then
            Fs.Close() : Return False
        End If
        ' التأكد من أن قيمة وحدة التحقق ما زالت كما وضعناها 
        If Fs.ReadByte <> ChecKByte Then
            Fs.Close() : Throw New Exception("هذا الملف غير صحيح")
        End If
        ' الانتقال إلى موضع السجل
        Fs.Position = 9 + Len(User) * (User.UserNo - 1)
        ' لو لم يكن رقم المستخدم هو رقم السجل فهذا معناه أن هناك من عبث بالملف
        If Fs.ReadInteger <> User.UserNo Then
            Fs.Close() : Throw New Exception("هذا الملف غير صحيح")
        End If
        ' التأكد من أن المعرّف المحفوظ مطابق للمعرّف المرسل
        If Fs.ReadInteger <> User.UserID Then
            Fs.Close()
            Return False
        End If
        Fs.Close() : Return True
    End Function

    Function CheckUser2(ByVal User As UserData2) As Boolean
        Dim Fs As New FileStream("C:\UsersData2.txt")
        Const ChecKByte As Byte = 236
        Fs.ReadInteger() ' قراءة عدد المستخدمين دون استغلاله
        If Fs.ReadInteger <> Len(User) Then
            Fs.Close() : Return False
        End If
        If Fs.ReadByte <> ChecKByte Then
            Fs.Close() : Throw New Exception("هذا الملف غير صحيح")
        End If

        Dim SavedUser As UserData2
        Do
            SavedUser = Fs.ReadStruc(Of UserData2)()
            If SavedUser.UserName Is Nothing Then
                Fs.Close() : Return False
            End If
            If RTrim(SavedUser.UserName) = User.UserName Then
                If RTrim(SavedUser.Password) <> User.Password Then
                    Fs.Close()
                    Return False
                End If
                Fs.Close() : Return True
            End If
        Loop
    End Function

End Module
