﻿Module Module1

    Delegate Sub MsgSub(ByVal Msg As String)

    Sub Show1(ByVal S As String)
        Console.WriteLine(S & " 1")
    End Sub

    Sub Show2(ByVal MessageText As String)
        Console.WriteLine(MessageText & " 2")
    End Sub

    Sub Show3(ByVal T As String)
        Console.WriteLine(T & " 3")
    End Sub

    Sub ShowMsg(ByVal M As MsgSub)
        Call M("Test Message")
    End Sub


    Sub Main()
        Dim M1 As MsgSub
        M1 = AddressOf Show1
        Call M1("Testing delegates")

        Dim M2 As MsgSub = AddressOf Show2
        Call M2("Testing delegates")

        Dim M3 As New MsgSub(AddressOf Show3)
        M3("Testing delegates")

        ShowMsg(AddressOf Show1) ' Test Message 1 ستظهر الرسالة 
        ShowMsg(AddressOf Show2) ' Test Message 2 ستظهر الرسالة 
        ShowMsg(AddressOf Show3) ' Test Message 3 ستظهر الرسالة 

        Dim M As MsgSub = AddressOf Show1
        ShowMsg(M) ' Test Message 1  ستظهر الرسالة
        M = AddressOf Show2
        ShowMsg(M) ' Test Message 2 ستظهر الرسالة 
        M = AddressOf Show3
        ShowMsg(M) ' Test Message 3 ستظهر الرسالة 

        Console.ReadLine()
    End Sub

End Module
