﻿Public Class Form1
    Dim Clc As New Clock

    Private Sub BtStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtStart.Click
        Clc.RingTime = DateAdd(DateInterval.Second, 5, Now)
        AddHandler Clc.Ring, AddressOf Clock_Ring
        AddHandler Clc.AllowStop, AddressOf Clock_AllowStop
        Clc.Start()

    End Sub

    Private Sub BtStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtStop.Click
        Clc.Stop()
        RemoveHandler Clc.Ring, AddressOf Clock_Ring
        RemoveHandler Clc.AllowStop, AddressOf Clock_AllowStop
    End Sub

    Sub Clock_Ring(ByVal Time As Date)
        BtStopRinging.Enabled = True
        Do
            Beep()
            Application.DoEvents()
            If StopRinging Then
                StopRinging = False
                Exit Sub
            End If
        Loop
    End Sub

    Private Sub Clock_AllowStop(ByRef Sender As Clock, ByRef StopClock As Boolean)
        Application.DoEvents()
    End Sub

    Dim StopRinging As Boolean
    Private Sub BtStopRinging_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtStopRinging.Click
        StopRinging = True
        BtStopRinging.Enabled = False
    End Sub
End Class


