﻿Public Class Form1
    Dim WithEvents UnDoReDo As New UndoRedo(Of String)(100, "")
    Dim DontChange As Boolean
    Dim SomeChanges As Boolean

    Private Sub UnDoReDo_ButtonState(ByVal CanUnDo As Boolean, ByVal CanReDo As Boolean) Handles UnDoReDo.ButtonState
        BtUnDo.Enabled = CanUnDo
        BtReDo.Enabled = CanReDo
    End Sub

    Private Sub TxtTest_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtTest.TextChanged
        If DontChange Then Exit Sub
        Dim T As String = TxtTest.Text
        Dim LastChar As String
        If Len(T) > 0 Then
            LastChar = Mid(T, Len(T), 1)
        Else
            LastChar = ""
        End If
        Select Case LastChar
            Case " ", vbCr, vbLf, ".", ",", "?", "!", "(", ")"
                UnDoReDo.ReportChanges(T)
                SomeChanges = False
            Case Else
                SomeChanges = True
                UnDoReDo.ClearReDo()
        End Select
        BtUnDo.Enabled = True
    End Sub

    Private Sub BtUnDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtUnDo.Click
        If SomeChanges Then
            UnDoReDo.ReportChanges(TxtTest.Text)
            SomeChanges = False
        End If
        DontChange = True
        TxtTest.Text = UnDoReDo.UnDo
        DontChange = False
    End Sub

    Private Sub BtReDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtReDo.Click
        DontChange = True
        TxtTest.Text = UnDoReDo.ReDo
        DontChange = False
    End Sub

End Class
