﻿Public MustInherit Class Stream
    Public MustOverride Sub Close()
    Public MustOverride Function ReadByte() As Integer
    Public MustOverride Function Read(ByRef Data As Byte(), Optional ByVal St As Integer = 0, Optional ByVal                 Count As Integer = 1) As Integer
    Public MustOverride Sub WriteByte(ByVal value As Byte)
    Public MustOverride Sub Write(ByVal Data() As Byte, Optional ByVal St As Integer = 0, Optional ByVal Count As Integer = 1)

    Enum SeekOrigin
        Begin = 0
        Current = 1
        [End] = 2
    End Enum

    Public MustOverride Function Seek(ByVal Offset As Long, Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long

    Protected pCanRead As Boolean = True
    Public MustOverride ReadOnly Property CanRead() As Boolean

    Protected pCanWrite As Boolean = True
    Public MustOverride ReadOnly Property CanWrite() As Boolean

    Public MustOverride ReadOnly Property Length() As Long

    Public MustOverride Property Position() As Long
End Class
