﻿Imports System.Runtime.CompilerServices

Module UserDefinedAggregates
    <Extension()> Function Median(ByVal IE As IEnumerable(Of Double)) As Double
        If IE.Count = 0 Then
            Throw New Exception("لا توجد عناصر")
        End If
        ' سنستخدم استعلاما لترتيب المجموعة
        Dim SortedColl = From Num In IE Order By Num
        Dim Value As Double
        Dim I = Int(SortedColl.Count / 2)
        If SortedColl.Count Mod 2 = 0 Then
            ' عدد العناصر زوجي
            Value = ((SortedColl(I) + SortedColl(I - 1)) / 2)
        Else
            ' عدد العناصر فردي
            Value = SortedColl(I)
        End If

        Return Value
    End Function

    <Extension()> Function Median(Of T)(ByVal IE As  _
                          IEnumerable(Of T), ByVal Convertor As Func(Of T, Double)) As Double
        Dim IC = From elem In IE Select Convertor(elem)
        Return IC.Median()
    End Function

End Module
