﻿Class DirctoryBrowser
    ' تعريف سجل معلومات مربع الحوار
    Private Structure BrowseInfo
        Dim hWndOwner As Integer
        Dim pIDLRoot As Integer
        Dim pszDisplayName As Integer
        Dim lpszTitle As Integer
        Dim ulFlags As Integer
        Dim lpfnCallback As Integer
        Dim lParam As Integer
        Dim iImage As Integer
    End Structure
    ' تعريف بعض الثوابت التي سنستخدمها
    Const BIF_RETURNONLYFSDIRS As Short = 1
    Const MAX_PATH As Short = 260
    ' تعريف دالة لتحرير الذاكرة بعد استخدامها
    Private Declare Sub CoTaskMemFree Lib "ole32.dll" _
                 (ByVal hMem As Integer)
    ' تعريف دالة عرض مربع الحوار
    Private Declare Function ShowDir Lib "shell32" Alias _
                 "SHBrowseForFolder" (ByRef lpbi As BrowseInfo) _
                 As Integer
    ' تعريف دالة للحصول على المجلد الذي اختاره المستخدم
    Private Declare Function SHGetPathFromIDList Lib _
                 "shell32" (ByVal pidList As Integer, _
                 ByVal lpBuffer As String) As Integer

    Shared Function Show(ByVal Parent As Form) As String
        Dim iNull As Short
        Dim lpIDList As Integer
        Dim strPath As String
        Dim udtBI As BrowseInfo

        With udtBI
            .hWndOwner = Parent.Handle.ToInt32
            .ulFlags = BIF_RETURNONLYFSDIRS
        End With

        ' عرض مربع حوار اختيار المجلد
        lpIDList = ShowDir(udtBI)
        If lpIDList Then
            strPath = New String(Chr(0), MAX_PATH)
            ' الحصول على مسار المجلد من القائمة
            SHGetPathFromIDList(lpIDList, strPath)
            ' تحرير الذاكرة المستخدمة
            CoTaskMemFree(lpIDList)
            ' لو كان النص يحتوي على "عدم"، فيجب أخذ ما قبلها من حروف فقط
            iNull = InStr(strPath, vbNullChar)
            If iNull Then strPath = Mid(strPath, 1, iNull - 1)
        End If
        Return strPath
    End Function
End Class
